/*
 * $Id: art.h,v 3.7 1991/09/03 22:07:23 adam Exp $
 */
/*
	Proprietary Rights of Inference Corporation in the 
	ART(R), ART Studio(TM), ARTIST(TM), ART-IM(R), 
	ART-IM Studio(TM), Viewpoints(TM), and CBR(TM) programs 
	include the following:
     
     1) The ART(R), ART Studio(TM), ARTIST(TM), ART-IM(R), 
	ART-IM Studio(TM), Viewpoints(TM), and CBR(TM) programs 
	and related data and information are the subject of 
	TRADE SECRETS and COPYRIGHTS licensed from 
	INFERENCE CORPORATION. 
        The program and related data and information are 
        provided in confidence and all use, disclosure, 
        copying, or storage except as authorized in the 
        written LICENSE AGREEMENT FROM INFERENCE to the 
        user, is strictly prohibited.
     
     2) COPYRIGHT (C) 1984-1991 INFERENCE CORPORATION, 
        550 N. Continental Blvd., El Segundo, California 90245. 
	PATENT PENDING.
        AN UNPUBLISHED WORK - - ALL RIGHTS RESERVED.
     
     3) RESTRICTED RIGHTS LEGEND:
        Use, reproduction, or disclosure of the Software by the 
	U.S. Government is subject to restrictions as set forth
	in the Rights in Technical Data and Computer Software
	clause at 52.227-19.
*/

/*
 ****************************************************
 *						    *
 * Public (user-visible) variables and definitions. *
 *						    *
 ****************************************************
 */

#ifndef _ART_INCLUDED
#define _ART_INCLUDED

/* The following sets the definition of NULL for compatibility with previous
   versions of ART-IM.  See the documentation on Passing Data Between ART-IM
   and C for further explanation. */
#if WINDOWS
#ifdef NULL
#undef NULL
#endif
#define NULL 0L
#endif

#if VM_FLAG
#define extern
#include "vmnames.h"
#endif

#if IBM_SASC_FLAG
#include "snames.h"
#endif

#include <setjmp.h>

#ifndef FILE
#include <stdio.h>
#endif

#if MSDOS_FLAG
#define VOID_PTR void *
typedef void *void_ptr;
#else
#define VOID_PTR long *
typedef long *void_ptr;
#endif

/* These internal definitions should be moved to another file to make
   them invisible to the user.  */
#ifdef ART_INTERNAL
typedef struct element *art_object;
typedef art_object art_template;
#else 
typedef VOID_PTR art_object;
typedef VOID_PTR art_template;
#endif

typedef art_object art_stream;
typedef art_object art_string;
typedef art_object art_symbol;
typedef art_object art_integer;
typedef art_object art_float;
typedef art_object art_fact;
typedef art_object art_sequence;
typedef art_object art_external_pointer;
typedef art_object art_function;
typedef art_object art_io_buffer;
typedef long boolean;

#define a_default_salience    0L        /* The default salience for an activation */
#define a_min_salience   -10000L    	/* The lowest salience allowed at the moment */
#define a_max_salience    10000L      	/* The highest salience allowed at the moment */


/* 
   The file protos.h has the public externs non-preprocessed.  This 
   file is ok for internal use but for releases the file proto.h should
   be included instead which has the preprocessed public externs.  This 
   file is created by "cc -P proto.c" followed by "mv proto.i proto.h".
*/
#ifdef ART_INTERNAL
#ifdef PROTOS
#include "protkern.h"
#else
#include "protos.h"
#endif
#else
#include "proto.h"
#endif


/* Useful constants. */
extern art_object a_nil;  /* nil */
extern art_object a_t;    /* t   */
extern art_object a_eof;  /* *EOF* symbol */
extern art_symbol a_stdin;
extern art_symbol a_stdout;
extern art_symbol a_stderr;
extern art_symbol a_debug_io;
extern art_symbol a_terminal_io;

/* exceptions */
extern art_symbol a_default_error;
extern art_symbol a_continue_error;
extern art_symbol a_memory_error;
extern art_symbol a_signal_error;
extern art_symbol a_program_error;
extern art_symbol a_arithmetic_error;
extern art_symbol a_type_error;
extern art_symbol a_value_error;
extern art_symbol a_file_error;
extern art_symbol a_stream_error;
extern art_symbol a_buffer_error;

/* public macros */

#if WINDOWS_FLAG
extern int pascal Catch(int *);
#define a_enable_restart(name, str) Catch((a_push_jmp_stack(name, str)))
#else
#define a_enable_restart(name, str) setjmp((a_push_jmp_stack(name, str)))
#endif

#define a_init() art_init(initfuns, initlibs, a_init_signals)

#endif
